;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;def inc for ek4
;ver00: th:  05/29/2002: initial version
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



;------------------------------------------------------------------------------
;
;       TECHNOLOGY RAM DEFINITIONS
;
;------------------------------------------------------------------------------
;
;RAMY            equ 0000h
;RAMY1           equ 0000h
;RAMY2           equ 1000h
;
;RAMY_UNKNOWN    equ RAMY1+0000h
;RAMY_KNOWN1     equ RAMY1+0100h
;RAMY_KNOWN2     equ RAMY1+0200h
;RAMY_KNOWN3     equ RAMY1+0300h
;RAMY_KNOWN4     equ RAMY1+0400h
;RAMY_KNOWN5     equ RAMY1+0500h
;RAMY_KNOWN6     equ RAMY1+0600h
;RAMY_MT_CXT     equ RAMY1+0700h
;
;RAMY_BLOCKS     equ RAMY2+0000h         ;1980 divides evenly into 9,10,11,12
;RAMY_WEIGHTS    equ RAMY2+07C0h         ;62 bytes available here
;
;RAMY_PLIER      equ RAMY_UNKNOWN+0FEh
;RAMY_CAND       equ RAMY2+07FEh
;
;; These pages are allocated for general use (especially by RP).  
;; They may NOT be used while wordspot is running.
;
;RAMY_SWAP       equ RAMY_KNOWN4
;RAMY_FLASH_BFR  equ RAMY_KNOWN5
;RAMY_FAT        equ RAMY_KNOWN6
;
;------------------------------------------------------------------------------

;use it for buffering data for MediaStick and bootload
;
;      buffer size = 256 Bytes: 1Mb to  4Mb MediaStick
;      buffer size = 512 Bytes: 8Mb to 16Mb MediaStick

;BUF_4X_RAMY              .EQU     0400h
;BUF_4X_RAMY2             .EQU     0500h
;BUF_4X_RAMY2STOP         .EQU     0600h

;------------------------------------------------------------------------------
;
;--- flagNF_size
;
;------------------------------------------------------------------------------

NFFLAG_SIZE_RESET         .EQU    000h
NFFLAG_SIZE_512Kb         .EQU    001h
NFFLAG_SIZE_1Mb           .EQU    002h
NFFLAG_SIZE_2Mb           .EQU    004h
NFFLAG_SIZE_4Mb           .EQU    008h
NFFLAG_SIZE_8Mb           .EQU    010h
NFFLAG_SIZE_16Mb          .EQU    020h

;------------------------------------------------------------------------------
;
;--- flagNF_rev
;
;------------------------------------------------------------------------------

NFFLAG_REV_RESET          .EQU    000h
NFFLAG_REV_A              .EQU    001h
NFFLAG_REV_B              .EQU    002h
NFFLAG_REV_C              .EQU    003h

;------------------------------------------------------------------------------
;
;--- address of NF Device Infor
;
;------------------------------------------------------------------------------

NF_DEVINFOR_ADDR_PART     .EQU    046
NF_DEVINFOR_ADDR_REV      .EQU    051

;------------------------------------------------------------------------------
;
;--- data of NF Device Infor
;
;------------------------------------------------------------------------------

NF_DEVINFOR_NX25F011     .EQU    008h           ;1Mbit part
NF_DEVINFOR_NX25F021     .EQU    009h           ;2Mbit part
NF_DEVINFOR_NX25F041     .EQU    00Ah           ;4Mbit part
NF_DEVINFOR_NX25F080     .EQU    005h           ;8Mbit part

NF_DEVINFOR_REV0         .EQU    000h           ;rev 0
NF_DEVINFOR_REVB1        .EQU    001h           ;rev B
NF_DEVINFOR_REVB2        .EQU    002h           ;rev B
NF_DEVINFOR_REVC         .EQU    003h           ;rev C


;------------------------------------------------------------------------------
;
;--- adddress of 4xEK signature in MediaStick
;
;------------------------------------------------------------------------------

NF_ADDR_SIG              .EQU    02h            ;2nd byte address

NF_ADDR_SIG_ID           .EQU    00h            ;1st byte address
NF_ADDR_SIG_CODESIZE     .EQU    10h            ;1st byte address
NF_ADDR_SIG_PROMPT       .EQU    20h            ;1st byte address


;------------------------------------------------------------------------------
;
;--- 4xEK signature in MediaStick
;
;------------------------------------------------------------------------------

INTRO_PROMPT_NO          .EQU   00000000b
INTRO_PROMPT_TALK        .EQU   00000001b
INTRO_PROMPT_SPX         .EQU   00000010b


;------------------------------------------------------------------------------
;
;--- ek4Flag
;
;------------------------------------------------------------------------------

PROMPT_CODESPACE         .EQU   00000001b



;------------------------------------------------------------------------------
;
;--- ek4 Button
;
;------------------------------------------------------------------------------


EK4BUT_TOUT              .EQU   11111111b
EK4BUT_LONG              .EQU   10000000b

EK4BUT_A                 .EQU   00000001b
EK4BUT_B                 .EQU   00000010b
EK4BUT_C                 .EQU   00000100b
EK4BUT_D                 .EQU   00001000b




