;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;signiture header for ek4
;
;ver02: th   2003 JAN 06: 'DefPort' is done in 'config.mca'
;ver01: th:  2003 SEP 27: added IO selectability
;ver00: th:  2002 NOV 01: initial version
;
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    .IF  .NOT SFR_PUBL_INCLUDED
        .ERROR 'You must include SFR_PUBL.INC before this file.'
    .ENDIF

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;
;      VR Stamp - Summary of IO Ports
;
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;P0.7: ---------------: APP           I (wp)
;P0.6: ---------------: SI            I (wp)
;P0.5: ---------------: SO            O
;P0.4: ---------------: SCK           O
;P0.3: ---------------: CS            O
;P0.2: ---------------: RS232 power   O
;P0.1: ---------------: RS232 TX      O
;P0.0: ---------------: RS232 RX      I (wp)
;--------------------------------------------
;P1.7: ---------------: SW D          I (sp)
;P1.6: ---------------: SW C          I (sp)
;P1.5: ---------------: SW B          I (sp)
;P1.4: ---------------: SW A          I (sp)
;P1.3: ---------------: LED D         O (RED)
;P1.2: ---------------: LED C         O (YEL-1)
;P1.1: ---------------: LED B         O (YEL-0)
;P1.0: ---------------: LED A         O (GRN)
;--------------------------------------------
;P2.7: ---------------: APP
;P2.6: ---------------: APP
;P2.5: ---------------: APP
;P2.4: ---------------: APP
;P2.3: ---------------: APP
;P2.2: ---------------: APP
;P2.1: ---------------: APP
;P2.0: ---------------: APP
;------------------------------------------------------------------------------


;------------------------------------------------------------------------------
;
;       LED

;------------------------------------------------------------------------------

        ExtrnPort LED_GRN
        ExtrnPort LED_YEL0
        ExtrnPort LED_YEL1
        ExtrnPort LED_RED

LED_GRN_ON .MACRO
        or      LED_GRN_out, #LED_GRN_bit
       .ENDMAC

LED_YEL0_ON .MACRO
        or      LED_YEL0_out, #LED_YEL0_bit
       .ENDMAC

LED_YEL1_ON .MACRO
        or      LED_YEL1_out, #LED_YEL1_bit
       .ENDMAC

LED_RED_ON .MACRO
        or      LED_RED_out, #LED_RED_bit
       .ENDMAC

        ;--------------------------------

LED_GRN_OFF .MACRO
        and     LED_GRN_out, #LED_GRN_bit_not
       .ENDMAC

LED_YEL0_OFF .MACRO
        and     LED_YEL0_out, #LED_YEL0_bit_not
       .ENDMAC

LED_YEL1_OFF .MACRO
        and     LED_YEL1_out, #LED_YEL1_bit_not
       .ENDMAC

LED_RED_OFF .MACRO
        and     LED_RED_out, #LED_RED_bit_not
       .ENDMAC

        ;--------------------------------

LED_GRN_TAG .MACRO
        xor     LED_GRN_out, #LED_GRN_bit
       .ENDMAC

LED_YEL0_TAG .MACRO
        xor     LED_YEL0_out, #LED_YEL0_bit
       .ENDMAC

LED_YEL1_TAG .MACRO
        xor     LED_YEL1_out, #LED_YEL1_bit
       .ENDMAC

LED_RED_TAG .MACRO
        xor     LED_RED_out, #LED_RED_bit
       .ENDMAC

;------------------------------------------------------------------------------
;
;       SWITCHES
;
;------------------------------------------------------------------------------

SW_PORT        .SET    P1In
SW_ALL_BTN     .EQU    11110000b

        ExtrnPort SW_D
        ExtrnPort SW_C
        ExtrnPort SW_B
        ExtrnPort SW_A

SW_D_TEST .MACRO
        tm      SW_D_in, #SW_D_bit
       .ENDMAC

SW_C_TEST .MACRO
        tm      SW_C_in, #SW_C_bit
       .ENDMAC

SW_B_TEST .MACRO
        tm      SW_B_in, #SW_B_bit
       .ENDMAC

SW_A_TEST .MACRO
        tm      SW_A_in, #SW_A_bit
       .ENDMAC

;------------------------------------------------------------------------------

