Attribute VB_Name = "Download"
Option Explicit

Public Function DownLoadCode(count As Long, bootSectorStart As Long, vrStamp As Boolean, skipFlash As Boolean, demoEval2 As Boolean) As Boolean
    Dim c As Integer
    Dim nBlocks As Long
    Dim i As Long, j As Long
    Dim retries As Integer
    Dim address As Long
    Dim buffer() As Byte
    Dim saveTimerDuration As Long
    
    
    DownLoadCode = False
    
    nBlocks = (count + 255) \ 256
    'nBlocks = 4
    
    With Form1.ProgressBar
        .Min = 0
        .Max = nBlocks
        .Value = 0
    End With
    
    If vrStamp Then
        ' erase entire chip
        Form1.txtStatus = Form1.txtStatus & vbCrLf & "Erasing code flash ..."
        Form1.txtStatus.Refresh
        SendByte CMD_ERASECODECHIP
        saveTimerDuration = timerDuration
        timerDuration = 10 * 10  ' 10 seconds (128KB part takes about 6 seconds)
        c = GetByte
        timerDuration = saveTimerDuration
        If c <> CODE_ACK Then GoTo ErrorExit
        Form1.txtStatus = Form1.txtStatus & "  Erase complete."
        Form1.txtStatus.Refresh
    End If
    

    For i = 0 To nBlocks - 1
        Form1.ProgressBar.Value = i + 1
        
        If cancel Then Exit Function
        address = i * 256
    
        If Not vrStamp And Not skipFlash Then
            If NeedToErase(address, bootSectorStart) Then
                If Not EraseSector(address) Then GoTo ErrorExit
            End If
        End If
        
     

        retries = 2
        Do While retries > 0
            DoEvents
            If Not skipFlash Then
                ' normal situation using CMD_DNLOADCODE

                If SendBuffer(address, 256, CMD_DNLOADCODE, True, demoEval2) Then Exit Do
            Else
                If SendBuffer(address, 256, CMD_DNLOADCODESRAM, False, True) Then Exit Do
            End If
            retries = retries - 1
        Loop
        If retries = 0 Then Exit For
    Next i
    If i <> nBlocks Then GoTo ErrorExit ' error in download
    If Form1.chkVerify = 0 Then
        DownLoadCode = True
        Exit Function
    End If
    
    Form1.txtStatus = Form1.txtStatus & vbCrLf & "Verifying ..."
    Form1.txtStatus.Refresh
    
    Dim cmd As Integer
    cmd = IIf(skipFlash, CMD_UPLOADCODESRAM, CMD_UPLOADCODE)
  

    For i = 0 To nBlocks - 1
        Form1.ProgressBar.Value = i + 1
        
        If cancel Then Exit Function
        address = i * 256
        retries = 2
        Do While retries > 0
            DoEvents
            If GetBuffer(address, 256, cmd, True, buffer) = 256 Then
                For j = 0 To 255
                    If buffer(j) <> data(address + j) Then
                        'Dim k As Integer
                        'GetBuffer 768, 256, CMD_UPLOADCODE, True, buffer
                        'For k = 0 To 255
                        '    Debug.Print k, buffer(k), data(768 + k)
                        'Next k
                        'Exit Function
                    
                        Form1.txtStatus = Form1.txtStatus & vbCrLf & _
                            Mismatch(address + j, data(address + j), buffer(j))
                        Form1.txtStatus.Refresh
                        Exit Function
                        'Debug.Print Hex(address + j), Hex(buffer(j)), Hex(data(address + j))
                    End If
                Next j
                Exit Do
            End If
            retries = retries - 1
        Loop
        If retries = 0 Then Exit For
    Next i
    If i <> nBlocks Then GoTo ErrorExit
    DownLoadCode = True
    Exit Function
ErrorExit:
    Form1.txtStatus = Form1.txtStatus & vbCrLf & "Communication Error!"
    Form1.txtStatus.Refresh
    DownLoadCode = False
    
End Function



Public Function DownLoadData(count As Long, blockSize As Integer, vrStamp As Boolean, demoEval2 As Boolean) As Boolean
    Dim c As Integer
    Dim nBlocks As Long
    Dim i As Long, j As Long
    Dim retries As Integer
    Dim address As Long
    Dim buffer() As Byte
    
    DownLoadData = False
    
    nBlocks = (count + blockSize - 1) \ blockSize
        
    With Form1.ProgressBar
        .Min = 0
        .Max = nBlocks
        .Value = 0
    End With
    
    ' erase entire chip
    If Not (vrStamp Or demoEval2) Then
        SendByte CMD_ERASEDATACHIP
        c = GetByte
        If c = -1 Then c = GetByte
        If c = -1 Then c = GetByte
        If c <> CODE_ACK Then GoTo ErrorExit
    End If
    
    For i = 0 To nBlocks - 1
        Form1.ProgressBar.Value = i + 1
        
        If cancel Then Exit Function
        address = i * blockSize
        retries = 2
        Do While retries > 0
            DoEvents
            If SendBuffer(address, blockSize, CMD_DNLOADDATA, Not (vrStamp Or demoEval2), False) Then Exit Do ' demoEval2) Then Exit Do
            retries = retries - 1
        Loop
        If retries = 0 Then Exit For
    Next i
    If i <> nBlocks Then GoTo ErrorExit ' error in download
    If Form1.chkVerify = 0 Then
        DownLoadData = True
        Exit Function
    End If
    
    Form1.txtStatus = Form1.txtStatus & vbCrLf & "Verifying ..."
    Form1.txtStatus.Refresh

 
    For i = 0 To nBlocks - 1
        Form1.ProgressBar.Value = i + 1
        
        If cancel Then Exit Function
        address = i * blockSize
        retries = 2
        Do While retries > 0
            DoEvents
            If GetBuffer(address, blockSize, CMD_UPLOADDATA, vrStamp, buffer) = blockSize Then
    
                For j = 0 To blockSize - 1
         
                    If buffer(j) <> data(address + j) Then
                        Form1.txtStatus = Form1.txtStatus & vbCrLf & _
                            Mismatch(address + j, data(address + j), buffer(j))
                        Form1.txtStatus.Refresh
                        Exit Function
                    End If
             
                 Next j
                 Exit Do
            End If
            retries = retries - 1
        Loop
        If retries = 0 Then Exit For
    Next i
    If i <> nBlocks Then GoTo ErrorExit
    DownLoadData = True
    Exit Function
ErrorExit:
    Form1.txtStatus = Form1.txtStatus & vbCrLf & "Communication Error!"
    Form1.txtStatus.Refresh
    DownLoadData = False
    
End Function

Public Function NeedToErase(address As Long, bootSectorStart As Long) As Boolean
    Dim addressLow As Long
   
    NeedToErase = True
    addressLow = address And &HFFFF&
    
    ' always erase at start of 64KB boundary
    
    If addressLow = 0 Then Exit Function
    If (address And &HF0000) = bootSectorStart Then
        ' boot sectors at 32KB, 8KB, 8KB and 16KB
        If addressLow = &H8000& Then Exit Function
        If addressLow = &HA000& Then Exit Function
        If addressLow = &HC000& Then Exit Function
    End If
    NeedToErase = False
End Function

Public Function EraseSector(address As Long) As Boolean
    Dim i As Integer
    Dim command() As Byte
    Dim saveTimerDuration As Long
    
    EraseSector = False
    
    ReDim command(0 To 4)
    command(0) = CMD_ERASECFSECTOR
    command(1) = address And &HFF
    command(2) = (address \ 256) And &HFF
    command(3) = (address \ 65536) And &HFF
    AddChecksum command, 1, 3
    
    If Not SendCommandAck(command) Then Exit Function
    
    saveTimerDuration = timerDuration
    timerDuration = 20
    If GetByte <> CODE_ACK Then Exit Function
    timerDuration = saveTimerDuration
    EraseSector = True
End Function

Public Function SendBuffer(address As Long, count As Integer, cmd As Integer, assumeErased As Boolean, supportConstant As Boolean) As Boolean
    Dim command() As Byte
    Dim i As Long
    Dim buffer() As Byte
    Dim allFF As Boolean, constant As Boolean
    Dim c As Byte
       
    allFF = True
    constant = True
    ReDim buffer(0 To count)
    For i = 0 To count - 1
        c = data(address + i)
        If c <> 255 Then allFF = False
        buffer(i) = c
        If c <> buffer(0) Then constant = False
    Next i
    
    If allFF And assumeErased Then
        SendBuffer = True
        Exit Function
    End If
    
    If supportConstant And constant Then
        count = 1   ' only send 1 byte
        ReDim Preserve buffer(0 To 1)
        Debug.Print buffer(0)
    End If
        
    AddChecksum buffer, 0, count - 1
    SendBuffer = False

    ReDim command(0 To 5)
    command(0) = cmd
    If (count = 512) Then
        command(1) = 1
    ElseIf (count = 1024) Then
        command(1) = 2
    Else
        command(1) = count And &HFF
    End If
    command(2) = address And &HFF
    command(3) = (address \ 256) And &HFF
    command(4) = (address \ 65536) And &HFF
    AddChecksum command, 1, 4
   
    If Not SendCommandAck(command) Then Exit Function
    
    Send buffer
     
    If GetByte <> CODE_ACK Then Exit Function
    SendBuffer = True
End Function

Public Function GetBuffer(address As Long, count As Integer, cmd As Integer, expectMode As Boolean, buffer() As Byte) As Integer
    Dim command() As Byte
    Dim mode As Integer
    Dim val As Integer
    Dim i As Integer
    Dim csum As Integer
        
    ReDim buffer(0 To count - 1)
    GetBuffer = 0
    
    ReDim command(0 To 5)
    command(0) = cmd
    If (count = 512) Then
        command(1) = 1
    ElseIf (count = 1024) Then
        command(1) = 2
    Else
        command(1) = count And &HFF
    End If
    command(2) = address And &HFF
    command(3) = (address \ 256) And &HFF
    command(4) = (address \ 65536) And &HFF
    AddChecksum command, 1, 4
   
    If Not SendCommandAck(command) Then
        Exit Function
    End If
    
   
' now receive the data.  for some uploads, first byte is flag:
'      0   buffer is constant and value follows
'      1   buffer is not constant

    csum = 0
    If expectMode Then
    
        mode = GetByte
        csum = mode
  
        If mode <> 0 And mode <> 1 Then Exit Function
    
        If mode = 0 Then
            val = GetByte
            If val = -1 Then
                Exit Function
            End If
            csum = csum Xor val
            For i = 0 To count - 1
                buffer(i) = val
            Next i
            GoTo GetCkSum
        End If
    End If
    
    For i = 0 To count - 1
        val = GetByte
        If val = -1 Then
            Exit Function
        End If
        buffer(i) = val
        csum = csum Xor val
    Next i
    
GetCkSum:
    
    ' get checksum and ACK
    
    val = GetByte
    If GetByte <> CODE_ACK Then Exit Function
    If val = -1 Then
        Exit Function
    End If
    csum = csum Xor val
    If csum = 0 Then
        GetBuffer = count
    Else
        i = i
    End If
End Function

Private Function Mismatch(address As Long, expected As Byte, read As Byte) As String
    Mismatch = "Error at address " & Hex(address) & _
        ": expected " & Hex(expected) & _
        " and read " & Hex(read)
End Function
