Attribute VB_Name = "FileInput"
Option Explicit

Public Function LoadBinaryFile(name As String) As Long
    Dim fn As Integer
    
    LoadBinaryFile = 0
    
    
    If Dir(name) = "" Then
        MsgBox "Error: unable to open file " & name & ".", vbOKOnly + vbCritical, "Open Error"
        Exit Function
    End If
    
    LoadBinaryFile = FileLen(name)
    
    If LoadBinaryFile = 0 Then
        MsgBox "Error: file " & name & " has zero length.", vbOKOnly + vbCritical, "Open Error"
        Exit Function
    End If
    
    If LoadBinaryFile > MAX_BUFFER_SIZE Then
        MsgBox "Error: file " & name & " is too large.", vbOKOnly + vbCritical, "Open Error"
        LoadBinaryFile = 0
        Exit Function
    End If
    
    fn = FreeFile
    Open name For Binary As #fn
    Get #fn, , data
    Close #fn
End Function

Private Function Convert8(s As String, i As Integer) As Integer
    Dim c As Byte
    
    c = Asc(Mid(s, i, 1))
    If c >= 48 And c <= 57 Then
        Convert8 = c - 48
    ElseIf c >= 65 And c <= 70 Then
        Convert8 = c - 55
    Else
        Convert8 = -1
        Exit Function
    End If
    c = Asc(Mid(s, i + 1, 1))
    If c >= 48 And c <= 57 Then
        Convert8 = Convert8 * 16 + c - 48
    ElseIf c >= 65 And c <= 70 Then
        Convert8 = Convert8 * 16 + c - 55
    Else
        Convert8 = -1
        Exit Function
    End If
End Function

Private Function Convert16(s As String, i As Integer) As Long
    Dim c As Byte
    
    c = Asc(Mid(s, i, 1))
    If c >= 48 And c <= 57 Then
        Convert16 = c - 48
    ElseIf c >= 65 And c <= 70 Then
        Convert16 = c - 55
    Else
        Convert16 = -1
        Exit Function
    End If
    
    c = Asc(Mid(s, i + 1, 1))
    If c >= 48 And c <= 57 Then
        Convert16 = Convert16 * 16 + c - 48
    ElseIf c >= 65 And c <= 70 Then
        Convert16 = Convert16 * 16 + c - 55
    Else
        Convert16 = -1
        Exit Function
    End If
    
    c = Asc(Mid(s, i + 2, 1))
    If c >= 48 And c <= 57 Then
        Convert16 = Convert16 * 16 + c - 48
    ElseIf c >= 65 And c <= 70 Then
        Convert16 = Convert16 * 16 + c - 55
    Else
        Convert16 = -1
        Exit Function
    End If
    
    c = Asc(Mid(s, i + 3, 1))
    If c >= 48 And c <= 57 Then
        Convert16 = Convert16 * 16 + c - 48
    ElseIf c >= 65 And c <= 70 Then
        Convert16 = Convert16 * 16 + c - 55
    Else
        Convert16 = -1
        Exit Function
    End If
    
End Function

Public Function LoadHexFile(name As String) As Long
    Dim fn As Integer
    Dim line As String
    Dim i As Long, count As Long, base As Long
    Dim recLen As Integer
    Dim recType As Integer
    Dim offset As Long
    Dim j As Integer
    Dim adrs As Long
    
    LoadHexFile = 0
    
    If Dir(name) = "" Then
        MsgBox "Error: unable to open file " & name & ".", vbOKOnly + vbCritical, "Open Error"
        Exit Function
    End If
    
    ' initialize buffer to all FF's
    
    For i = 0 To MAX_BUFFER_SIZE - 1
        data(i) = &HFF
    Next i
    
    fn = FreeFile
    Open name For Input As #fn
    
    On Error GoTo ErrorExit
    
    count = -1
    base = 0
    
    Do While Not EOF(fn)
        Line Input #fn, line
        line = UCase(line)
        If line <> "" Then
            If Left(line, 1) <> ":" Then
                MsgBox "Error: file " & name & " does not appear to be Intel Hex Format.", _
                    vbOKOnly + vbCritical, "Open Error"
                Close #fn
                Exit Function
            End If
            recLen = Convert8(line, 2)
            offset = Convert16(line, 4)
            recType = Convert8(line, 8)
            
            If recType = 0 Then
            
               ' data record
                
                For j = 0 To recLen - 1
                    adrs = base + offset + j
                    If adrs >= MAX_BUFFER_SIZE Then
                        MsgBox "Error: file " & name & " exceeds maximum size of buffer.", _
                            vbOKOnly + vbCritical, "Open Error"
                        Close #fn
                    Exit Function
                    End If
                    
                    data(adrs) = CByte(Convert8(line, j * 2 + 10))
                    If adrs > count Then count = adrs
                Next j
                                  
            ElseIf recType = 4 Then
                ' page record
                base = Convert16(line, 10) * 65536
                
            ElseIf recType <> 1 Then    ' if not EOF type
                  MsgBox "Error: file " & name & " has unsupported record type: " & recType, _
                    vbOKOnly + vbCritical, "Open Error"
                Close #fn
                Exit Function
            End If

        End If
        
    Loop
    Close #fn
    
    ' make last address into number of bytes loaded
    
    count = count + 1
    
    ' round up to nearest multiple of 256
    
    'count = (count + 255) And &HFFF00
    LoadHexFile = count
    Exit Function
ErrorExit:
    MsgBox "Error: bad format", vbOKOnly + vbCritical, "Load Error"
    Close #fn
End Function


