Attribute VB_Name = "GetCommPorts"
Option Explicit

Declare Function GetDefaultCommConfig Lib "kernel32" Alias "GetDefaultCommConfigA" (ByVal lpszName As String, lpCC As COMMCONFIG, lpdwSize As Long) As Long
Declare Function GetCommProperties Lib "kernel32" (ByVal hFile As Long, lpCommProp As COMMPROP) As Long
Declare Function GetCommState Lib "kernel32" (ByVal nCid As Long, lpDCB As DCB) As Long
Declare Function SetCommState Lib "kernel32" (ByVal hCommDev As Long, lpDCB As DCB) As Long



Type DCB
        DCBlength As Long
        baudRate As Long
        fBitFields As Long 'See Comments in Win32API.Txt
        wReserved As Integer
        XonLim As Integer
        XoffLim As Integer
        ByteSize As Byte
        Parity As Byte
        StopBits As Byte
        XonChar As Byte
        XoffChar As Byte
        ErrorChar As Byte
        EofChar As Byte
        EvtChar As Byte
        wReserved1 As Integer 'Reserved; Do Not Use
End Type


Type COMMPROP
        wPacketLength As Integer
        wPacketVersion As Integer
        dwServiceMask As Long
        dwReserved1 As Long
        dwMaxTxQueue As Long
        dwMaxRxQueue As Long
        dwMaxBaud As Long
        dwProvSubType As Long
        dwProvCapabilities As Long
        dwSettableParams As Long
        dwSettableBaud As Long
        wSettableData As Integer
        wSettableStopParity As Integer
        dwCurrentTxQueue As Long
        dwCurrentRxQueue As Long
        dwProvSpec1 As Long
        dwProvSpec2 As Long
        wcProvChar(1) As Integer
End Type


Type COMMCONFIG
    dwSize As Long
    wVersion As Integer
    wReserved As Integer
    dcbx As DCB
    dwProviderSubType As Long
    dwProviderOffset As Long
    dwProviderSize As Long
    wcProviderData(0 To 255) As Byte
End Type

Type PORT_INFO_1
        pName As String
End Type

Type PORT_INFO_2
        pPortName As String
        pMonitorName As String
        pDescription As String
        fPortType As Long
        Reserved As Long
End Type

'Declare Function EnumPorts Lib "winspool.drv" Alias "EnumPortsA" (ByVal pName As String, ByVal Level As Long, ByVal lpbPorts As Long, ByVal cbBuf As Long, pcbNeeded As Long, pcReturned As Long) As Long
Declare Function EnumPorts Lib "winspool.drv" Alias "EnumPortsA" (name As Long, ByVal Level As Long, ByVal lpbPorts As Long, ByVal cbBuf As Long, pcbNeeded As Long, pcReturned As Long) As Long


Public Sub GetAvailableCommPorts()
    Dim cc As COMMCONFIG
    Dim result As Long
    Dim size As Long
    Dim port As String
    Dim i As Integer

    With Form1.cbxPort
        .Clear
        For i = 1 To 4
            .AddItem "Com" & i
        Next i
    End With

    On Error GoTo ErrorExit
    For i = 5 To 16
        port = "Com" & i
        size = 0
        result = GetDefaultCommConfig(port, cc, size)
        If size > 0 Then
            Form1.cbxPort.AddItem port
        End If
    Next i
ErrorExit:
End Sub


' Set baud rate using Win32 API.
' The PortOpen property should be set to True before calling.
' May raise the following errors:
'   comPortNotOpen  the PortOpen property has not been set to True
'   comDCBError     failed to read current state of the port
'   comSetCommStateFailed  failed to set new baud rate
Public Function SetBaudRate(Com As MSComm, baud As Long) As Long
    Dim ComDcb As DCB
    Dim result As Long
    
    On Error GoTo ErrorExit
    SetBaudRate = 0
    
    ' Check port is open
    
    If Not Com.PortOpen Then Exit Function
    
    ' Get existing Comm state
    result = GetCommState(Com.CommID, ComDcb)
    If result = 0 Then Exit Function
        
    ' Modify state with new baud rate
    
    ComDcb.baudRate = baud
    
    ' Set the new Comm state
    
    result = SetCommState(Com.CommID, ComDcb)
    If result = 0 Then Exit Function
    
    SetBaudRate = baud
ErrorExit:
End Function


