VERSION 5.00
Begin VB.Form frmWatchDebug 
   BackColor       =   &H00C0FFFF&
   Caption         =   "Watch Debug Output"
   ClientHeight    =   3795
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   9000
   Icon            =   "frmWatchDebug.frx":0000
   LinkTopic       =   "Form2"
   ScaleHeight     =   3795
   ScaleWidth      =   9000
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdHelp 
      BackColor       =   &H00C0E0FF&
      Caption         =   "Help"
      Height          =   375
      Left            =   7680
      Style           =   1  'Graphical
      TabIndex        =   5
      Top             =   3120
      Width           =   975
   End
   Begin VB.CheckBox chkEnable 
      BackColor       =   &H00C0FFFF&
      Caption         =   "Enable Watch"
      Height          =   255
      Left            =   480
      TabIndex        =   4
      Top             =   3120
      Value           =   1  'Checked
      Width           =   1455
   End
   Begin VB.CommandButton cmdClear 
      BackColor       =   &H00C0E0FF&
      Caption         =   "Clear"
      Height          =   375
      Left            =   4800
      Style           =   1  'Graphical
      TabIndex        =   3
      Top             =   3120
      Width           =   1095
   End
   Begin VB.CommandButton cmdExit 
      BackColor       =   &H00C0E0FF&
      Caption         =   "Exit"
      Height          =   375
      Left            =   6240
      Style           =   1  'Graphical
      TabIndex        =   2
      Top             =   3120
      Width           =   1095
   End
   Begin VB.CheckBox chkTranslate 
      BackColor       =   &H00C0FFFF&
      Caption         =   "Translate T2SI Debug Output"
      Height          =   255
      Left            =   2160
      TabIndex        =   1
      Top             =   3120
      Value           =   1  'Checked
      Width           =   2400
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   4680
      Top             =   1320
   End
   Begin VB.TextBox txtWatchDebug 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2775
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   120
      Width           =   8775
   End
End
Attribute VB_Name = "frmWatchDebug"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim widthDelta As Integer
Dim heightDelta As Integer
Dim buttonDelta As Integer
Dim activated As Boolean
Dim ResultLabelWidth As Integer

Const NUM_HISTORY_LINES = 1000

Dim history(0 To NUM_HISTORY_LINES - 1) As String
Dim nHistory As Integer
Dim mostRecent As Integer
Dim ResultLabel(0 To 255) As String
Dim timerCounter As Integer

Private Sub chkEnable_Click()
    txtWatchDebug.SetFocus
End Sub

Private Sub chkTranslate_Click()
    txtWatchDebug.SetFocus
End Sub

Private Sub cmdClear_Click()
    txtWatchDebug.Text = ""
    nHistory = 0
    mostRecent = 0
    txtWatchDebug.SelStart = 0
    txtWatchDebug.SetFocus
End Sub

Private Sub cmdExit_Click()
    activated = False
    Me.Hide
End Sub



Private Sub Form_Activate()
    Dim line As String
    Dim tag As String
    Dim ch As String
    Dim s As String
    If activated Then Exit Sub
    activated = True
    
    nHistory = 0
    mostRecent = 0
    txtWatchDebug.Text = ""
    txtWatchDebug.SelStart = 0
    txtWatchDebug.SetFocus
    Form1.MSComm1.InputLen = 1
        
    If Form1.MSComm1.InBufferCount > 0 Then
       Form1.MSComm1.InBufferCount = 0
    End If
    GoTo NewLine    ' first time, pretend just saw CRLF
MainLoop:
    If Not activated Then GoTo ExitForm
    txtWatchDebug.SetFocus
    Do While activated
        If Form1.MSComm1.InBufferCount > IN_BUFFER_SIZE / 2 Then
            Form1.MSComm1.InBufferCount = 0 ' not keeping up
        End If
        Do While activated And Form1.MSComm1.InBufferCount > 0
            ch = Form1.MSComm1.Input
            If ch = Chr(10) Then GoTo NewLine
        Loop
        DoEvents
    Loop
    If Not activated Then GoTo ExitForm
    
    
NewLine:
    tag = GetChars(1)
    If Not activated Then GoTo ExitForm
    If tag = "" Then GoTo NewLine
    
    If tag = "T" And chkTranslate.Value > 0 Then
        Dim tmp As String
        tmp = ProcessT2SIEvent
        PrintLine tmp
    Else
        s = tag
        timerCounter = 3
        Do While activated And timerCounter > 0
            If Form1.MSComm1.InBufferCount > 0 Then
                ch = Form1.MSComm1.Input
                timerCounter = 3
                If ch = Chr(10) Then
                    PrintLine s
                    GoTo NewLine
                    
                ElseIf Asc(ch) >= Asc(" ") Then
                    s = s & ch
                End If
            End If
            DoEvents
        Loop
        If activated Then PrintLine s
    End If
    
    If activated Then GoTo MainLoop
ExitForm:
    Me.Hide
End Sub

Private Function GetChars(cnt As Integer) As String
    Dim ch As String
    GetChars = ""
    Do While activated
        If Form1.MSComm1.InBufferCount > IN_BUFFER_SIZE / 2 Then
            Form1.MSComm1.InBufferCount = 0 ' not keeping up
            GetChars = ""
            Exit Function
        End If
        
        Do While Form1.MSComm1.InBufferCount > 0
            ch = Form1.MSComm1.Input
            If Asc(ch) < Asc(" ") Then
                GetChars = ""
                Exit Function
            End If
            GetChars = GetChars & ch
            cnt = cnt - 1
            If cnt = 0 Then
                'Debug.Print GetChars
                Exit Function
            End If
        Loop
        DoEvents
    Loop
    GetChars = ""
    
End Function

Private Sub Form_Load()
    ' load errors.txt if it exists
    
    
    Dim fn As Integer
    Dim i As Integer, j As Integer
    Dim line As String
    
    For i = 0 To 255: ResultLabel(i) = "": Next i
    ResultLabelWidth = 2 ' assume results are 2-digit hex
    On Error GoTo SkipError
    If Dir(App.Path & "\errors.txt") <> "" Then
        fn = FreeFile
        Open App.Path & "\errors.txt" For Input As #fn
        Do While Not EOF(fn)
            Line Input #fn, line
            line = Trim(line)
            If Len(line) > 0 Then
                If Left(line, 1) <> ";" Then
                    i = val("&h" & Left(line, 2))
                    line = Mid(line, 3)
                    line = Trim(line)
                    j = InStr(1, line, " ")
                    If j > 0 Then line = Left(line, j - 1)
                    'If Left(line, 4) = "ERR_" Then line = Mid(line, 5)
                    ResultLabel(i) = line
                    If Len(line) > ResultLabelWidth Then ResultLabelWidth = Len(line)
                    'Debug.Print i, line
                End If
            End If
        Loop
        Close #fn
    End If
SkipError:
    On Error GoTo 0
    
    txtWatchDebug = ""
    widthDelta = txtWatchDebug.Width - Me.Width
    heightDelta = txtWatchDebug.Height - Me.Height
    buttonDelta = cmdExit.Top - Me.Height
    activated = False
End Sub

Private Sub Form_QueryUnload(cancel As Integer, UnloadMode As Integer)
    If activated Then
        cancel = True
        activated = False
    End If
    
End Sub

Private Sub Form_Resize()
    If Me.WindowState <> vbMinimized Then
        txtWatchDebug.Width = Me.Width + widthDelta
        txtWatchDebug.Height = Me.Height + heightDelta
        chkEnable.Top = Me.Height + buttonDelta
        chkTranslate.Top = Me.Height + buttonDelta
        cmdExit.Top = Me.Height + buttonDelta
        cmdClear.Top = Me.Height + buttonDelta
        cmdHelp.Top = Me.Height + buttonDelta
    End If
End Sub

Private Sub PrintLine(s As String)
    Dim tmp As String
    Dim i As Integer
    
    'Debug.Print s
    
    If chkEnable.Value = 0 Then Exit Sub
    
    mostRecent = mostRecent + 1
    If mostRecent = NUM_HISTORY_LINES Then mostRecent = 0
    If nHistory < NUM_HISTORY_LINES Then nHistory = nHistory + 1
    history(mostRecent) = s
    i = mostRecent - (nHistory - 1)
    If i < 0 Then i = i + NUM_HISTORY_LINES
    tmp = ""
    Do
        tmp = tmp & history(i) & vbCrLf
        If i = mostRecent Then Exit Do
        i = i + 1
        If i = NUM_HISTORY_LINES Then i = 0
    Loop
    txtWatchDebug.Text = tmp
    txtWatchDebug.SelStart = Len(tmp)
End Sub


Private Function ExtractHexByte(s As String) As Integer
    Dim c As Integer
    ExtractHexByte = -1
    If Len(s) <> 2 Then Exit Function
    c = Asc(Mid(s, 1, 1))
    If (c < Asc("0") Or c > Asc("9")) And (c < Asc("A") Or c > Asc("F")) Then Exit Function
    c = Asc(Mid(s, 2, 1))
    If (c < Asc("0") Or c > Asc("9")) And (c < Asc("A") Or c > Asc("F")) Then Exit Function
    ExtractHexByte = val("&h" & s)
End Function


Private Function ExtractDecimalWord(s As String) As Long
    Dim c As Integer
    Dim i As Integer
    ExtractDecimalWord = -1
    If Len(s) <> 5 Then Exit Function
    For i = 1 To 5
        c = Asc(Mid(s, i, 1))
        If c < Asc("0") Or c > Asc("9") Then Exit Function
    Next i
    ExtractDecimalWord = val(s)
End Function


Private Function ExtractDecimalByte(s As String) As Integer
    Dim c As Integer
    Dim i As Integer
    ExtractDecimalByte = -1
    If Len(s) <> 3 Then Exit Function
    For i = 1 To 3
        c = Asc(Mid(s, i, 1))
        If c < Asc("0") Or c > Asc("9") Then Exit Function
    Next i
    ExtractDecimalByte = val(s)
End Function

Private Function FormatDecWord(n As Long) As String
    FormatDecWord = n
    If Len(FormatDecWord) < 5 Then FormatDecWord = FormatDecWord & Space(5 - Len(FormatDecWord))
End Function

Private Function FormatDecByte(n As Integer) As String
    FormatDecByte = n
    If Len(FormatDecByte) < 3 Then FormatDecByte = FormatDecByte & Space(3 - Len(FormatDecByte))
End Function

Private Function ProcessT2SIEvent() As String
    Dim resultCode As Integer
    Dim silLevel As Long
    Dim peakLevel As Long
    Dim gainByte As Integer
    Dim duration As Long
    Dim nSegments As Integer
    Dim score As Long, gScore As Long, wordNumber As Integer
    Dim tmp As String, s As String, t As String, rc As String
    On Error GoTo ErrorExit
    
    ProcessT2SIEvent = "?"
    
    rc = Trim(GetChars(4))
    resultCode = ExtractHexByte(rc)
    If resultCode = -1 Then Exit Function
    tmp = RTrim(GetChars(6))
    silLevel = ExtractDecimalWord(tmp)
    If silLevel = -1 Then Exit Function
    tmp = RTrim(GetChars(6))
    peakLevel = ExtractDecimalWord(tmp)
    If peakLevel = -1 Then Exit Function
    tmp = RTrim(GetChars(3))
    gainByte = ExtractHexByte(tmp)
    If gainByte = -1 Then Exit Function
    tmp = RTrim(GetChars(6))
    duration = ExtractDecimalWord(tmp)
    If duration = -1 Then Exit Function
    tmp = GetChars(3)
    nSegments = ExtractDecimalByte(tmp)
    If nSegments = -1 Then Exit Function
   

    If ResultLabel(resultCode) <> "" Then s = s & ResultLabel(resultCode)
    s = s & Space(ResultLabelWidth - Len(s))
    s = s & " SIL " & FormatDecWord(silLevel) & " PEAK " & FormatDecWord(peakLevel)
    If gainByte And &H80 Then
        s = s & " FAR "
    ElseIf gainByte And &H40 Then
        s = s & "HSET"
    Else
        s = s & "ARMS"
    End If
    s = s & " HGAIN " & ((gainByte And &H30) \ 16)
    s = s & " SGAIN " & ((gainByte And &HC) \ 4) ' & "->" & (gainByte And &H3)
    s = s & " DUR " & FormatDecWord(duration)
    
    Do While nSegments > 0
        tmp = LTrim(GetChars(4))
        wordNumber = ExtractDecimalByte(tmp)
        If wordNumber = -1 Then Exit Function
        tmp = LTrim(GetChars(6))
        score = ExtractDecimalWord(tmp)
        If score = -1 Then Exit Function
        tmp = LTrim(GetChars(6))
        gScore = ExtractDecimalWord(tmp)
        If gScore = -1 Then Exit Function
        s = s & vbCrLf & "   ID " & FormatDecByte(wordNumber)
        s = s & "  S " & FormatDecWord(score) & "  G " & FormatDecWord(gScore)
        nSegments = nSegments - 1
    Loop

    ProcessT2SIEvent = s
ErrorExit:
    
End Function

Private Sub Timer1_Timer()
    If timerCounter > 0 Then timerCounter = timerCounter - 1
End Sub

Private Sub cmdHelp_Click()
    frmHelp.Show vbModal
    Unload frmHelp
    txtWatchDebug.SetFocus
End Sub
